Create fulfillment - Fabric

Create fulfillment

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/carts/{cartId}/fulfillments \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "type": "SHIP_TO",
  "price": {
    "amount": 12.99
  },
  "refId": "398427903843",
  "attributes": {
    "source": "store"
  },
  "originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "locationId": "CA",
  "pickupPerson": {
    "secondary": [
      {
        "name": {
          "first": "John",
          "middle": "S",
          "last": "Doe"
        },
        "email": "john@test.com",
        "phone": {
          "number": "123-456-7890",
          "type": "MOBILE"
        }
      }
    ]
  }
}
'

Python Example

import requests

url = "https://api.fabric.inc/v3/carts/{cartId}/fulfillments"

payload = {
    "type": "SHIP_TO",
    "price": { "amount": 12.99 },
    "refId": "398427903843",
    "attributes": { "source": "store" },
    "originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
    "destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
    "locationId": "CA",
    "pickupPerson": { "secondary": [
            {
                "name": {
                    "first": "John",
                    "middle": "S",
                    "last": "Doe"
                },
                "email": "john@test.com",
                "phone": {
                    "number": "123-456-7890",
                    "type": "MOBILE"
                }
            }
        ] }
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript Example

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    type: 'SHIP_TO',
    price: {amount: 12.99},
    refId: '398427903843',
    attributes: {source: 'store'},
    originAddress: 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
    destinationAddress: 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
    locationId: 'CA',
    pickupPerson: {
      secondary: [
        {
          name: {first: 'John', middle: 'S', last: 'Doe'},
          email: 'john@test.com',
          phone: {number: '123-456-7890', type: 'MOBILE'}
        }
      ]
    }
  })
};

fetch('https://api.fabric.inc/v3/carts/{cartId}/fulfillments', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP Example

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/carts/{cartId}/fulfillments",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'type' => 'SHIP_TO',
    'price' => [
        'amount' => 12.99
    ],
    'refId' => '398427903843',
    'attributes' => [
        'source' => 'store'
    ],
    'originAddress' => 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
    'destinationAddress' => 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
    'locationId' => 'CA',
    'pickupPerson' => [
        'secondary' => [
                [
                                'name' => [
                                                                'first' => 'John',
                                                                'middle' => 'S',
                                                                'last' => 'Doe'
                                ],
                                'email' => 'john@test.com',
                                'phone' => [
                                                                'number' => '123-456-7890',
                                                                'type' => 'MOBILE'
                                ]
                ]
        ]
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Go Example

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/carts/{cartId}/fulfillments"

payload := strings.NewReader("{\n  \"type\": \"SHIP_TO\",\n  \"price\": {\n    \"amount\": 12.99\n  },\n  \"refId\": \"398427903843\",\n  \"attributes\": {\n    \"source\": \"store\"\n  },\n  \"originAddress\": \"a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93\",\n  \"destinationAddress\": \"a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93\",\n  \"locationId\": \"CA\",\n  \"pickupPerson\": {\n    \"secondary\": [\n      {\n        \"name\": {\n          \"first\": \"John\",\n          \"middle\": \"S\",\n          \"last\": \"Doe\"\n        },\n        \"email\": \"john@test.com\",\n        \"phone\": {\n          \"number\": \"123-456-7890\",\n          \"type\": \"MOBILE\"\n        }\n      }\n    ]\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Examples

Success Response

{
  "id": "d6229cdb-0c5b-4885-b1b2-13b94d02488e",
  "type": "SHIP_TO",
  "refId": "398427903843",
  "attributes": {
    "source": "store"
  },
  "originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "locationId": "CA",
  "pickupPerson": {
    "primary": {
      "name": {
        "first": "John",
        "middle": "S",
        "last": "Doe"
      },
      "email": "john@test.com",
      "phone": {
        "number": "123-456-7890",
        "type": "MOBILE"
      }
    },
    "secondary": [
      {
        "name": {
          "first": "John",
          "middle": "S",
          "last": "Doe"
        },
        "email": "john@test.com",
        "phone": {
          "number": "123-456-7890",
          "type": "MOBILE"
        }
      }
    ]
  },
  "price": {
    "amount": 12.99
  }
}

Error Response

{
  "type": "BAD_REQUEST",
  "message": "x-fabric-tenant-id is required"
}
{
  "type": "CART_NOT_FOUND",
  "message": "Cart not found"
}